1 / 31

On linear and semidefinite programming relaxations for hypergraph matching

This work explores linear and semidefinite programming relaxations for hypergraph matching problems. It focuses on finding a largest subset of disjoint hyperedges and discusses known approximation results. The paper also introduces new techniques for improving local search algorithms and presents an algorithmic proof of the integrality gap for k-dimensional matching.

nathanson
Download Presentation

On linear and semidefinite programming relaxations for hypergraph matching

An Image/Link below is provided (as is) to download presentation Download Policy: Content on the Website is provided to you AS IS for your information and personal use and may not be sold / licensed / shared on other websites without getting consent from its author. Content is provided to you AS IS for your information and personal use only. Download presentation by click this link. While downloading, if for some reason you are not able to download a presentation, the publisher may have deleted the file from their server. During download, if you can't get a presentation, the file might be deleted by the publisher.

E N D

Presentation Transcript


  1. On linear and semidefinite programming relaxations for hypergraph matching (work appeared in SODA 10’) Yuk Hei Chan (Tom) joint work with Lap Chi Lau @ CUHK

  2. Hypergraph matching: find a largest subset of disjoint hyperedges Known approximation results: Θ(√n) [Halldórsson, Kratochvíl, Telle 98’] k-Set Packing: each hyperedge has k vertices Hypergraph Matching Vertex set V: |V| = n Hyperedge set E [Hazan, Safra, Schwartz 03’]: Ω ( k / log(k) ) hardness

  3. Latin square completion k-Dimensional Matching column j 1 4 row i, column j row i 2 k row i, color k 3 2 3 4 column j, color k Special Cases of k-Set Packing e1 e1 e2 e2 • Bounded degree independent set e4 e3 e3 e4

  4. Local optimal — t-opt solution Greedy solution = 1-opt solution Greedy solution is k-approximate Running time and performance guarantee depends on t Previous Work: Local Search Improve: add ≤ t edges in, remove fewer edges t = 2 t = 3

  5. Previous Work: Local Search

  6. No projective plane as a sub-hypergraph — integrality gap k − 1 Non-algorithmic, do not directly imply approximation algorithm Previous Work: Linear Programming Relaxation [Füredi 81’] integrality gap = k − 1 + 1/k (unweighted) [Füredi, Kahn, Seymour 93’] integrality gap = k − 1 + 1/k (weighted)

  7. Projective plane (of order k – 1) k2− k + 1 hyperedges Degree k on each vertex Pairwise intersecting Exists when k − 1 is a prime power LP solution: 1/k on every edge gives k − 1 + 1/k Integral solution: 1 Previous Work: Integrality Gap Examples k = 3: Fano plane "order 3 projective plane"... Integrality gap = k − 1 + 1/k

  8. Tight algorithmic analysis of the standard LP relaxation Strengthening of LP by local constraints Fano LP & Sherali-Adams relaxation Improvement but not much Strengthening of LP by global constraints “Clique” LP & SDP Improve by a constant factor over local constraints New connection between local search and LP/SDP Overview of New Results

  9. Algorithmic proof of gap k − 1 for k-Dimensional Matching Improve the local search algorithms by ε New technique: iterative rounding + local ratio Standard LP Relaxation Tight algorithmic analysis of the standard LP relaxation k − 1 + 1/k for k-Set Packing Theorem 1: A 2-approximation algorithm for weighted 3-D Matching

  10. For unweighted 3-Set Packing, Main proof idea: in this Fano LP, any basic solution has no Fano plane! Then apply Füredi’s result directly Better LP? Can we write a better LP? add Fano plane constraint: ≤ 1 Theorem 2: Fano LP integrality gap = 2

  11. Sherali-Adams will add all local constraints on edges after rounds: Capture all local constraints on hyperedges No integrality gap for any set of hyperedges e.g. 7 rounds to get Fano plane constraint Better LP? Can we improve further by adding more local constraints? Simplify by linearizing and projecting where are disjoint edge subsets with ≤ 1

  12. A modified projective plane Still an intersecting family optimal = 1 Fractional solution ≥ k – 2 Bad example for Sherali-Adams hierarchy Theorem 3: SA gap is at least k − 2 after Ω(n / k3) rounds

  13. Global Constraints Clique constraint: for a set of intersecting edges, allow sum of values ≤ 1 Theorem 4: “Clique” LP integrality gap ≤ (k + 1) / 2 Some new connections between local search and LP/SDP relaxations ≤ (k + 1) / 2 Local OPT OPT Clique LP Extend local search analysis Non-constructive; no rounding algorithm

  14. Clique LP Clique LP has exponentially many constraints and no separation oracle is known ≤ (k + 1) / 2 Local OPT OPT Clique LP Theorem 5: Clique LP has a compact representation when k is a constant • Use a result in extremal combinatorics There is polynomial size LP with smaller integrality gap than SA relaxations

  15. SDP Indirect way of bounding SDP gap ≤ (k + 1) / 2 Local OPT OPT SDP Clique LP Lovász theta function is an SDP formulation for the independent set problem. [Grötschel, Lovász, Schrijver]:SDP captures the clique constraints A way to improve k-Set Packing? Theorem 6: Lovász theta function has integrality gap ≤ (k + 1) / 2

  16. Details explained... 2-approximation for 3-D matching Integrality gap ≤ (k + 1) / 2 for clique LP

  17. Compute a basic solution Find a good ordering iteratively with small neighborhood Use local ratio to compute an approximate solution Approximation Algorithm for k-D Matching Theorem 1: A 2-approximation algorithm for weighted 3-D Matching Same algorithm for k-Set Packing gives k − 1 + 1/k

  18. 1. Basic Solution Only degree constraints can be tight. Delete edges with xe = 0. Basic solution: # variables≤# tight constraints in a basic solution Lemma: in a basic solution, there is a vertex with degree at most 2

  19. Suppose not, then Since each edge consists of 3 vertices, so In a basic solution, , so Let T be the set of tight vertices, i.e. vertices s.t. Basic Solution Lemma: in a basic solution, there is a vertex with degree at most 2 Let E' be the set of non-zero edges, i.e. edges s.t. xe > 0

  20. Since the graph is 3-partite, Every edge in E' consist of vertices in T only Basic Solution • Constraints are not linearly independent, i.e. solution is not basic Lemma: in a basic solution, there is a vertex with degree at most 2

  21. 2. Small (fractional) Neighborhood Lemma: in a basic solution, there is a vertex with degree at most 2 xb xa ( xb ) + ( ≤ xb ) + ( ≤ 1 − xb ) + ( ≤ 1 − xb ) ≤ 2 This gives 2 approx. for unweighted case.

  22. Pick the green edge:Gain 2, lose (up to) 91 Weighted Case The same algorithm does not work in the weighted case. we = 80xe= 0.2 we = 2xe = 0.8 we = 10xe= 0.2 we = 1xe= 0.2

  23. Weighted Case Strategy: Write fractional solution as a linear combination of matchings. xe= 0.3 × 0.3 × 0.3 xe= 0.7 × 0.4 × 0.3 xe= 0.4 by averaging, there is a matching of large weight. If sum of coefficients is small,

  24. Ordering Procedure Repeat Find an edge e with x(N[e]) ≤ 2,add it to the ordering. Remove e from the graph Until the graph is empty Finding Good Ordering Lemma: in a basic solution, there is a vertex with degree at most 2 Idea: Use Lemma to find a good ordering, then apply greedy coloring xb xa ≤ 1 − xb ∑ xe ≤ 1 − xb ∑ xe ≤ 2 (xa ≤ 1 − xb) Lemma: there is an ordering of edge e1, e2, …,em s.t. x(N[ei] ∩ {ei, ei+1, …em}) ≤ 2

  25. Apply greedy coloring Lemma: there is an ordering of edge e1, e2, …,em s.t. x(N[ei] ∩ {ei, ei+1, …em}) ≤ 2 e4 Use greedy coloring, color the edges in reverse order e3 e2 Decompose the fractional solution x as a linear combination of matchings Mi: , where e1 e5 • By averaging argument, there is a matching with weight at least half of the optimum • Implies integrality gap at most 2 Not an efficient algorithm yet Need local ratio

  26. 3. Fractional Local Ratio Split the weight vector into 2. (Number denotes weight) Step 5: join the solution Step 4: remove non-positive edges and solve the residue instance Step 3: distribute the weight Step 2: make a copy of the graph in the neighborhood of the blue edge Step 1: pick an edge with ∑ xe ≤ 2 in the closed neighborhood (by Lemma) 10 10 0 10 20 10 10 10 0 7 10 7 -3 25 13 13 3 10 20 ∑ xe ≤ 2: pick any edge here = 2-approx. Obtain a 2-approximate solution by induction This is a 2-approximate solution

  27. Clique LP has integrality gap ≤ (k + 1) / 2 Strategy: Fix a 2-local optimal matching M, bound the ratio of any fractional solution Extend local search analysis M Not rounding algorithm F: set of non-zero edges F2 F1 Want to show: x(F) ≤ (k + 1) |M| / 2

  28. Clique LP has integrality gap ≤ (k + 1) / 2 Let Claim: F1(e) is an intersecting family for x(F1(e)) ≤ 1 M Otherwise, exists disjoint f1, f2 in F1(e) e Replace e by f1, f2 x(F1(e)) ≤ 1 x(F1) ≤ |M| f1 f2 F1(e)

  29. There are k |M| vertices in M By degree constraint, x(F2) ≤ k |M| Each edge intersect ≥ 2 edges in M Clique LP has integrality gap ≤ (k + 1) / 2 M x(F2) ≤ k |M| / 2 F2 Theorem 4: “Clique” LP integrality gap ≤ (k + 1) / 2

  30. Between Ω(k / log k) to (k + 1) / 2 o(k) ? Open Problems More “Iterative Rounding + Local Ratio” rounding algorithms? What is the integrality gap of the SDP? • Lower bound on the integrality gap? What is the approximability of k-Set Packing?

  31. End

More Related